#pragma once
#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgBandwidthControl.h" //Pawcio: BC
#include "PPgServer.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgStats.h"
#include "PPgNotify.h"
#include "PPgIRC.h"
#include "PPgTweaks.h"
#include "PPgDisplay.h"
#include "PPgSecurity.h"
#include "PPgWebServer.h"
#include "PPgScheduler.h"
#include "PPgProxy.h"
#include "TreePropSheet.h"
#include "PPgBobo.h"	// bobo eigene Seite
#include "PPgBobo2.h"	// bobo2 eigene Seite
#include "PPgBobo3.h"	// bobo3 eigene Seite
#include "PPgBobo4.h"	// bobo4 eigene Seite
#include "PPgBobo5.h"	// bobo5 eigene Seite
#include "./WebCache/PPgWebcachesettings.h" // WebCache: jp
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
#include "PPgDebug.h"
#endif
#include "otherfunctions.h"
#include "TreePropSheet.h"
#include "ListBoxST.h"
#include "KCSideBannerWnd.h" 	// [TPT] - New Preferences Banner	

class CPreferencesDlg : public CTreePropSheet
{
	DECLARE_DYNAMIC(CPreferencesDlg)

public:
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgBandwidthControl	m_wndBC; //Pawcio: BC
	CPPgServer		m_wndServer;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;
	CPPgStats		m_wndStats;
	CPPgNotify		m_wndNotify;
	CPPgIRC			m_wndIRC;
	CPPgTweaks		m_wndTweaks;
	CPPgDisplay		m_wndDisplay;
	CPPgSecurity	m_wndSecurity;
	CPPgWebServer	m_wndWebServer;
	CPPgScheduler	m_wndScheduler;
	CPPgProxy		m_wndProxy;
	CPPgBobo        m_wndBobo;		// bobo eigene Seite
	CPPgBobo2       m_wndBobo2;		// bobo2 eigene Seite
	CPPgBobo3       m_wndBobo3;		// bobo3 eigene Seite
	CPPgBobo4       m_wndBobo4;		// bobo4 eigene Seite
	CPPgBobo5       m_wndBobo5;		// bobo5 eigene Seite
	CPPgWebcachesettings	m_wndWebcachesettings; // WebCache: jp
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	CPPgDebug		m_wndDebug;
#endif

	void Localize();
	void SetStartPage(UINT uStartPageID);
	void UpdateBCStatus();//Pawcio: BC

protected:
	LPCTSTR m_pPshStartPage;
	bool m_bSaveIniFile;

	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg void OnDestroy();
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
protected:
	CKCSideBannerWnd m_banner;	// [TPT] - New Preferences Banner
};
